#!/usr/bin/perl

#
#	Strip (and check) parity bits (high bit) from file
#

use Getopt::Std;

$self = "StripParity.pl";

binmode(STDIN);
binmode(STDOUT);

$parityCheck = "e";
$linepos = 1;
$charpos = 1;
$lastlfcr = 0;

getopts('p:') || usage();
if($opt_p) {
	$parityCheck = $opt_p;
}


while(1) {
	
	if(read(STDIN,$ch,1) != 1) {
		last;
	}

	print STDOUT chr(ord($ch) & 0x7f);

	$thechar = ord($ch);
	$parity = 0;
	for($i = 1; $i < 256; $i = $i * 2) {
		if($thechar & $i) {
			$parity = 1 - $parity;
		}
	}

	if($parityCheck eq "e" && $parity != 0) {
		print STDERR "Even Parity error line $linepos character $charpos\n";
	}
	elsif($parityCheck eq "o" && $parity == 0) {
		print STDERR "Odd Parity error line $linepos character $charpos\n";
	}

	if(!$lastlfcr && ($ch eq "\r" || $ch eq "\n")) {
		++$linepos;
		$lastlfcr = 1;
		$charpos = 0;
	}
	elsif($ch ne "\r" && $ch ne "\n") {
		$lastlfcr = 0;
		++$charpos;
	}
}

exit(0);

sub usage() {
	print "Usage:  perl $self [-p e|o|x] < input-file > output-file\n";
	print "\te == even, o = odd, x is strip, no checking.\n";
	print "\tDefault is -p e\n";

}
